unit ChannelConfigFrameUnit;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TChannelConfigFrame = class(TFrame)
    ChLabel: TLabel;
    TareButton: TButton;
    Label1: TLabel;
    ScaleEdit: TEdit;
    procedure TareButtonClick(Sender: TObject);
    procedure ScaleEditChange(Sender: TObject);
  private
    { Private declarations }
  public
    Index: Integer;
    { Public declarations }
  end;

type
  TChannelData = record
    Code: Word;
    Tare: Word;
    Scale: Real;
    Frame: TChannelConfigFrame;
  end;

var
  ChannelData: array[0..12] of TChannelData = (
{
all LVDTs .5
Fahr
1800
1800
400
50
}
    ( Code: $0000; Tare: $8000; Scale: 0.5/$8000; ),
    ( Code: $1000; Tare: $8000; Scale: 0.5/$8000; ),
    ( Code: $2000; Tare: $8000; Scale: 0.5/$8000; ),
    ( Code: $3000; Tare: $8000; Scale: 0.5/$8000; ),
    ( Code: $4000; Tare: $8000; Scale: 0.5/$8000; ),
    ( Code: $5000; Tare: $8000; Scale: 0.5/$8000; ),
    ( Code: $6000; Tare: $8000; Scale: 0.5/$8000; ),
    ( Code: $7000; Tare: $8000; Scale: 0.5/$8000; ),
    ( Code: $0014;              Scale: 1; ), //Temperature reference.
    ( Code: $2010; Tare: $8000; Scale: 1800/$8000; ),
    ( Code: $4010; Tare: $8000; Scale: 1800/$8000; ),
    ( Code: $6010; Tare: $8000; Scale: 400/$8000; ),
    ( Code: $7010; Tare: $8000; Scale: 50/$8000; )
  );

implementation

{$R *.DFM}

uses
  MainUnit;

procedure TChannelConfigFrame.TareButtonClick(Sender: TObject);
begin
  MainForm.DoTare(Index);
end;

procedure TChannelConfigFrame.ScaleEditChange(Sender: TObject);
begin
  try
    ChannelData[Index].Scale := 1 / StrToFloat(ScaleEdit.Text);

    ScaleEdit.Color := clWindow;
    ScaleEdit.ParentFont := True;
  except
    ScaleEdit.Color := $000080;
    ScaleEdit.Font.Color := $FFFFFF;
  end;
end;

end.
