unit ConfigUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls;

type
  TConfigForm = class(TForm)
    Label1: TLabel;
    IntervalPanel: TPanel;
    IntervalEdit: TEdit;
    IntervalUpDown: TUpDown;
    Label2: TLabel;
    procedure IntervalUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure IntervalEditChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IntervalEditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure IntervalEditKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ConfigForm: TConfigForm;

implementation

{$R *.DFM}

uses
  ChannelConfigFrameUnit;

procedure TConfigForm.IntervalUpDownClick(Sender: TObject; Button: TUDBtnType);
var
  NewStr: String;

begin
  NewStr := Format('%.1f', [IntervalUpDown.Position / 10]);
  if NewStr <> IntervalEdit.Text then IntervalEdit.Text := NewStr;
end;

procedure TConfigForm.IntervalEditChange(Sender: TObject);
var
  NewVal: Integer;

begin
  try
    NewVal := Round(StrToFloat(IntervalEdit.Text) * 10);
    if NewVal <> IntervalUpDown.Position then begin
      IntervalUpDown.Position := NewVal;
      if (NewVal < 1) or (NewVal > 3600) then IntervalUpDownClick(nil, btNext);
    end;

    IntervalEdit.Color := clWindow;
    IntervalEdit.ParentFont := True;
  except
    IntervalEdit.Color := $000080;
    IntervalEdit.Font.Color := $FFFFFF;
  end;
end;

procedure TConfigForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caHide;
end;

procedure TConfigForm.IntervalEditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_UP then begin
    Key := 0;
    IntervalUpDown.Position := IntervalUpDown.Position + 1;
    IntervalUpDownClick(nil, btNext);
  end
  else if Key = VK_DOWN then begin
    Key := 0;
    IntervalUpDown.Position := IntervalUpDown.Position - 1;
    IntervalUpDownClick(nil, btPrev);
  end;
end;

procedure TConfigForm.IntervalEditKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_UP) or (Key = VK_DOWN) then Key := 0;
end;

procedure TConfigForm.FormCreate(Sender: TObject);
var
  I, BaseY: Integer;

begin
  BaseY := IntervalPanel.Top + IntervalPanel.Height;
  for I := 0 to High(ChannelData) do with ChannelData[I] do begin
    Tare := 0;
    Frame := TChannelConfigFrame.Create(Self);
    Frame.Name := '';
    Frame.Index := I;
    Frame.Align := alTop;
    Frame.Top := BaseY + I * 33;

    Frame.ChLabel.Caption := 'Channel'#13 + IntToHex(I, 1) + '   (' + IntToHex((Code shr 4) and $F, 1) + '.' + IntToHex((Code shr 12) and $F, 1) + ')';
    Frame.ScaleEdit.Text := FloatToStr(1/Scale);

    Frame.Parent := Self;
  end;
  ClientHeight := BaseY + Length(ChannelData) * 33;
end;

end.
